import { AbstractControlOptions, AsyncValidatorFn, FormGroup, ValidatorFn } from '@angular/forms';
import { ClassType } from 'class-transformer/ClassTransformer';
import { ValidatorOptions } from 'class-validator';
import 'reflect-metadata';
import { BehaviorSubject, Subject, Subscription } from 'rxjs';
import { Dictionary } from '../models/dictionary';
import { FormModel } from '../models/form-model';
import { ShortValidationErrors } from '../models/short-validation-errors';
export declare class DynamicFormGroup<TModel> extends FormGroup {
    factoryModel: ClassType<TModel>;
    fields?: FormModel<TModel> | undefined;
    nativeValidateErrors: BehaviorSubject<Dictionary<any>>;
    customValidateErrors: BehaviorSubject<ShortValidationErrors>;
    formErrors: ShortValidationErrors;
    formFields: Dictionary;
    objectChange: Subject<unknown>;
    valueChangesSubscription: Subscription;
    private _object;
    private _externalErrors;
    private _validatorOptions;
    private _fb;
    constructor(factoryModel: ClassType<TModel>, fields?: FormModel<TModel> | undefined, validatorOrOpts?: ValidatorFn | ValidatorFn[] | AbstractControlOptions | null, asyncValidator?: AsyncValidatorFn | AsyncValidatorFn[] | null);
    subscribeToValueChanges(externalErrors?: ShortValidationErrors, validatorOptions?: ValidatorOptions): void;
    set externalErrors(externalErrors: ShortValidationErrors);
    get externalErrors(): ShortValidationErrors;
    set validatorOptions(validatorOptions: ValidatorOptions);
    get validatorOptions(): ValidatorOptions;
    set object(object: TModel);
    get object(): TModel;
    validate(externalErrors?: ShortValidationErrors, validatorOptions?: ValidatorOptions): void;
    validateAsync(externalErrors?: ShortValidationErrors, validatorOptions?: ValidatorOptions): Promise<void>;
    setCustomErrors(allErrors: any): void;
    private collectErrors;
    validateAllFormFields(): void;
    resetValidateAllFormFields(): void;
    classToClass<TClassModel>(object: TClassModel): TClassModel;
    plainToClass<TClassModel, Object>(cls: ClassType<TClassModel>, plain: Object): TClassModel;
    setExternalErrorsAsync(externalErrors: ShortValidationErrors): Promise<void>;
    setExternalErrors(externalErrors: ShortValidationErrors): void;
    getExternalErrors(): ShortValidationErrors;
    clearExternalErrors(): void;
    clearExternalErrorsAsync(): Promise<void>;
    setValidatorOptionsAsync(validatorOptions?: ValidatorOptions): Promise<void>;
    setValidatorOptions(validatorOptions?: ValidatorOptions): void;
    getValidatorOptions(): ValidatorOptions;
    private onlyFields;
    private markAsInvalidForExternalErrors;
    /**
     * Recursively gets all values from the form controls and all sub form group and array controls and returns it as
     * an object
     */
    private getObject;
    /**
     * Sets the value of every control on the form and recursively sets the values of the controls
     * on all sub form groups
     *
     * @param object the data to assign to all controls of the form group and sub groups
     */
    private setObject;
}
export declare function getClassValidators<TModel>(factoryModel: ClassType<TModel>, fields?: Dictionary, validatorOptions?: ValidatorOptions): {};
